import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;

@SuppressWarnings({"unchecked", "serial"})


/************************************************************
	O:	DialogLogIn
	@\:	̃Xe[^X̐ݒ
************************************************************/

public class FieldLoginDialog extends JDialog
	implements ActionListener, ChangeListener, Basis
{

public static final int SELECT_OK = 1;
public static final int SELECT_CANCEL = 2;
public static final int SELECT_CLOSE = 3;

public static final int defaultW = 250;
public static final int defaultH = 250;

private static String title;
private static String err_title;
private static String err_message;

private ComboBoxModel cbm;

private JComboBox adr;
private JTextField na;
private JButton ok, no;
private JSlider ad, ds;
private JLabel atc, def, spd;
private JRadioButton sos, pc, watch;

private int select;
private String address;
private String name;


/************************************************************
					ݒ and ֌W
************************************************************/

static
{
	title = "ݒ";
	err_title = "mF";
	err_message = "̖O͎gp邱Ƃł܂";
}

public FieldLoginDialog(Frame f)
{
	super(f, title, true);
//	Toolkit.getDefaultToolkit().beep();

	select = SELECT_CLOSE;
	address = name = null;

	int w = defaultW;
	int h = defaultH;

	Container c = getContentPane();
	
	ButtonGroup group = new ButtonGroup();
	sos = new JRadioButton("SOSc");
	pc = new JRadioButton("Rs[^");
	watch = new JRadioButton("ϐ");
	group.add(sos);
	group.add(pc);
	group.add(watch);
	sos.addActionListener(this);
	pc.addActionListener(this);
	watch.addActionListener(this);
	sos.setSelected(true);

	ok = new JButton("OK");
	ok.addActionListener(this);
	ok.setSelected(true);
	no = new JButton("CANCEL");
	no.addActionListener(this);

	ad = new JSlider(0, 100, 33);
	ds = new JSlider(0, 100, 66);
	ad.addChangeListener(this);
	ds.addChangeListener(this);
	ds.setPaintLabels(true);
	ds.setPaintTicks(true);
	ds.setMajorTickSpacing(20);
	ds.setMinorTickSpacing(10);

	atc = new JLabel("atc = "+ad.getValue());
	def = new JLabel("def = "+(ds.getValue()-ad.getValue()));
	spd = new JLabel("spd = "+(ds.getMaximum()-ds.getValue()));

	setLayout(null);

	sos.setBounds(10, 10, 230, 20);
	pc.setBounds(10, 30, 230, 20);
	watch.setBounds(10, 50, 230, 20);

	atc.setBounds(20, 80, 60, 20);
	def.setBounds(100, 80, 60, 20);
	spd.setBounds(170, 80, 60, 20);
	ad.setBounds(20, 105, 210, 20);
	ds.setBounds(17, 125, 216, 50);

	ok.setBounds(20, 185, 95, 20);
	no.setBounds(135, 185, 95, 20);

	c.add(sos);
	c.add(pc);
//	c.add(watch);
	c.add(ok);
	c.add(no);

	c.add(atc);
	c.add(def);
	c.add(spd);
	c.add(ad);
	c.add(ds);

	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width-w)/2, (d.height-h)/2);
	setSize(w, h);
	setVisible(true);
}


/************************************************************
					ANV֌W
************************************************************/

public void actionPerformed(ActionEvent e)
{
	if(e.getSource() == ok){
		select = SELECT_OK;
		setVisible(false);
	}
	else if(e.getSource() == no){
		select = SELECT_CANCEL;
		setVisible(false);
	}
}

public void stateChanged(ChangeEvent e)
{
	if(e.getSource() == ad){
		if(ad.getValue() > ds.getValue())	ds.setValue(ad.getValue());
		setLabel();
	}
	else if(e.getSource() == ds){
		if(ad.getValue() > ds.getValue())	ad.setValue(ds.getValue());
		setLabel();
	}
}

private void setLabel()
{
	atc.setText("atc = "+ad.getValue());
	def.setText("def = "+(ds.getValue()-ad.getValue()));
	spd.setText("spd = "+(ds.getMaximum()-ds.getValue()));
}



/************************************************************
					f[^[ANZX֌W
************************************************************/

public int getSelect(){		return select;						}
public int getBelong()
{
	if(sos.isSelected())			return Base.SOS_PARTY;
	else if(pc.isSelected())		return Base.PC_STUDYS;
	else if(watch.isSelected())		return Base.WATCH;
	else							return Base.OTHER;
}

public int getArea(){	return FIELD_0;							}
public int getAtc(){	return ad.getValue();					}
public int getDef(){	return ds.getValue()-ad.getValue();		}
public int getSpd(){	return ds.getMaximum()-ds.getValue();	}

}
