import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.lang.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import javax.imageio.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import java.util.*;
import static java.awt.RenderingHints.*;


public class Function extends Object implements Basis
{

public static boolean test;
public static boolean log;
public static boolean elog;
public static boolean sound;
private static JFrame f;
private static PrintStream ps;

static
{
	test = TEST;
	log = TEST;
	elog = TEST;
	sound = TEST;
	f = new JFrame();
	ps = null;
}

public static void setTest(boolean t)
{
	test = t;
}

public static void setLog(boolean l)
{
	log = l;
}

public static void setErrorLog(boolean l)
{
	elog = l;
}

public static void setSound(boolean s)
{
	sound = s;
}

public static void setFrame(JFrame jf)
{
	f = jf;
}

public static void Option(String args[])
{
	for(String data : args){
		if(data.equals("test"))			test = true;
		else if(data.equals("log"))		log = true;
		else if(data.equals("nomal"))	test = false;
	}
}

public static void SystemOutput()
{
	if(!elog || !test)	return;

	try{
		File f = new File("error_"+Function.saveFileName());
		f.setReadOnly();
		System.setOut(new PrintStream(f));
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}

public static void LogStreamOpen()
{
	if(!log)	return;

	try{
		File f = new File("tdos_"+saveFileName());
		f.setReadOnly();
		ps = new PrintStream(f);
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}

public static void LogStreamClose()
{
	if(ps == null)	return;

	try{
		ps.flush();
		ps.close();
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}
public static void LogWrite(String data)
{
	if(ps == null)	return;

	try{
		ps.println(data);
		ps.flush();
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
}



public static Font setFont(StringTokenizer st, String all, Font f)
{
	if(st.countTokens() == 0)				return setFont("Dialog", Font.PLAIN, 12, f);

	if(st.countTokens() == 1){
		String data = st.nextToken();

		if(data.equals("AA"))				return setFont("MS PGothic", Font.PLAIN, 12, f);
		else if(data.equals("PAA"))				return setFont("MS PGothic", Font.PLAIN, 16, f);
		else if(data.equals("big"))			return setFont(null, -1, f.getSize()+1, f);
		else if(data.equals("small"))		return setFont(null, -1, f.getSize()-1, f);
		else if(data.equals("plain"))		return setFont(null, Font.PLAIN, -1, f);
		else if(data.equals("bold"))		return setFont(null, Font.BOLD, -1, f);
		else if(data.equals("italic"))		return setFont(null, Font.ITALIC, -1, f);
		else if(data.equals("bold+italic"))	return setFont(null, Font.BOLD+Font.ITALIC, -1, f);
		else if(data.equals("italic+bold"))	return setFont(null, Font.BOLD+Font.ITALIC, -1, f);
		else if(data.equals("B"))			return setFont(null, Font.BOLD, -1, f);
		else if(data.equals("I"))			return setFont(null, Font.ITALIC, -1, f);
		else if(data.equals("B+I"))			return setFont(null, Font.BOLD+Font.ITALIC, -1, f);
		else if(data.equals("I+B"))			return setFont(null, Font.BOLD+Font.ITALIC, -1, f);
		else if(data.equals("show"))		return null;
	}

	if(st.countTokens() < 2)			return f;
	String command = st.nextToken();
	String type = st.nextToken();

	if(st.countTokens() == 0){	
		if(command.equals("size")){
			int n = Extraction(type);
			if(n != -1)	return setFont(null, -1, n, f);
		}
	}

	if(st.countTokens() >= 0){
		if(command.equals("name")){
			int n = all.indexOf("\"")+1;
			int m = all.lastIndexOf("\"");

			if(m != all.length()-1)	return f;
			if(n >= m)				return f;
			all = all.substring(n, m);

			Font[] fo = GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts();
			for(n=0;n<fo.length;n++){
				if(	all.equals(fo[n].getFamily()) || 
					all.equals(fo[n].getFontName()) || 
					all.equals(fo[n].getName()))
				{
					
					return setFont(all, -1, -1, f);
				}
			}
		}
	}
	return f;
}

public static Font setFont(String name, int style, int size, Font f)
{
	if(name == null)	name = f.getName();
	if(style == -1)		style = f.getStyle();
	if(-1 == size)		size = f.getSize();
	else if(size < 8)	size = 8;
	else if(72 < size)	size = 72;

	return new Font(name, style, size);
}
/*
public static void setFontSelect(StringTokenizer st, String all, JTextAreaScroll ta)
{
	if(st.countTokens() == 0){
		setFont("Dialog", Font.PLAIN, 12, ta);
		return;
	}

	if(st.countTokens() == 1){
		String data = st.nextToken();

		if(data.equals("AA"))				setFont("MS PGothic", Font.PLAIN, 12, ta);
		else if(data.equals("big"))			setFont(null, -1, ta.getFont().getSize()+1, ta);
		else if(data.equals("small"))		setFont(null, -1, ta.getFont().getSize()-1, ta);
		else if(data.equals("plain"))		setFont(null, Font.PLAIN, -1, ta);
		else if(data.equals("bold"))		setFont(null, Font.BOLD, -1, ta);
		else if(data.equals("italic"))		setFont(null, Font.ITALIC, -1, ta);
		else if(data.equals("bold+italic"))	setFont(null, Font.BOLD+Font.ITALIC, -1, ta);
		else if(data.equals("italic+bold"))	setFont(null, Font.BOLD+Font.ITALIC, -1, ta);
		else if(data.equals("B"))			setFont(null, Font.BOLD, -1, ta);
		else if(data.equals("I"))			setFont(null, Font.ITALIC, -1, ta);
		else if(data.equals("B+I"))			setFont(null, Font.BOLD+Font.ITALIC, -1, ta);
		else if(data.equals("I+B"))			setFont(null, Font.BOLD+Font.ITALIC, -1, ta);
		else if(data.equals("show")){
			String sty = " of style ";
			Font f = ta.getFont();
			switch(f.getStyle()){
				case Font.PLAIN:			sty += "plain";			break;
				case Font.BOLD:				sty += "bold";			break;
				case Font.ITALIC:			sty += "italic";			break;
				case Font.BOLD+Font.ITALIC:	sty += "bold and italic";	break;
			}

			ta.addText("It changed to size "+f.getSize()+sty+" of font "+f.getName()+".");
			return;
		}
		return;
	}

	if(st.countTokens() < 2)	return;
	String command = st.nextToken();
	String type = st.nextToken();

	if(st.countTokens() == 0){	
		if(command.equals("size")){
			int n = Extraction(type);
			if(n != -1)	setFont(null, -1, n, ta);
		}
	}

	if(st.countTokens() >= 0){
		if(command.equals("name")){
			int n = all.indexOf("\"")+1;
			int m = all.lastIndexOf("\"");

			if(m != all.length()-1)	return;
			if(n >= m)				return;
			all = all.substring(n, m);

			Font[] f = GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts();
			for(n=0;n<f.length;n++){
				if(	all.equals(f[n].getFamily()) || 
					all.equals(f[n].getFontName()) || 
					all.equals(f[n].getName())
				){
					setFont(all, -1, -1, ta);
					return;
				}
			}
		}
	}
}

public static void setFont(String name, int style, int size, JTextAreaScroll ta)
{
	if(name == null)	name = ta.getFont().getName();
	if(style == -1)		style = ta.getFont().getStyle();
	if(-1 == size)		size = ta.getFont().getSize();
	else if(size < 8)	size = 8;
	else if(72 < size)	size = 72;


	Font f = new Font(name, style, size);
	if(!ta.getFont().equals(f))	ta.setFont(f);
	else							return;
}
*/
public static Color setColor(StringTokenizer st, String all, Color val)
{
	if(st.countTokens() == 0)	return new Color(0xffffff);
	else if(st.countTokens() == 1){
		String data = st.nextToken();

		if(data.equals("show"))					return null;
		else if(data.indexOf("black") == 0)		return Color.black;
		else if(data.indexOf("blue") == 0)		return Color.blue;
		else if(data.indexOf("cyan") == 0)		return Color.cyan;
		else if(data.indexOf("gray") == 0)		return Color.gray;
		else if(data.indexOf("green") == 0)		return Color.green;
		else if(data.indexOf("magenta") == 0)	return Color.magenta;
		else if(data.indexOf("orange") == 0)	return Color.orange;
		else if(data.indexOf("pink") == 0)		return Color.pink;
		else if(data.indexOf("red") == 0)		return Color.red;
		else if(data.indexOf("white") == 0)		return Color.white;
		else if(data.indexOf("yellow") == 0)	return Color.yellow;

		else if(data.indexOf("darkcyan") == 0)	return new Color(0x008B8B);
		else if(data.indexOf("violet") == 0)	return new Color(0xC86FFF);
		else if(data.indexOf("gold") == 0)		return new Color(0xFFD700);
		else if(data.indexOf("") == 0)		return new Color(0x99FF66);
	}
	else if(st.countTokens() == 2){
		String data = "";
		String data1 = st.nextToken();
		String data2 = st.nextToken();

		data = data1 + " " + data2;
		if(data.indexOf("dark gray") == 0)			return Color.darkGray;
		else if(data.indexOf("light gray") == 0)	return Color.lightGray;
		else if(data.indexOf("light blue") == 0)	return new Color(0x87CEFA);

		else if(data1.indexOf("set") == 0){
			int n = -1;
			if(data2.indexOf("0x") == 0)		n = Extraction(data2.substring(2), 16);
			else if(data2.indexOf("#") == 0)	n = Extraction(data2.substring(1), 16);
			else if(data2.indexOf("\\u") == 0)	n = Extraction(data2.substring(2), 16);
			else 								n = Extraction(data2, 16);

			if(0 <= n && n <= 0xffffff)	return new Color(n);
		}
	}
	else if(st.countTokens() == 4){
		String data[] = new String[4];

		for(int n=0;n<data.length;n++)
			data[n] = st.nextToken();

		if(data[0].indexOf("set") == 0){
			int v[] = new int[3];

			for(int n=0;n<3;n++){
				v[n] = Extraction(data[n+1]);
				if(0 <= v[n] && v[n] <= 0xff)	continue;
				return val;
			}
			return new Color(v[0], v[1], v[2]);
		}
	}
	else if(st.countTokens() == 5){
		String data[] = new String[5];

		for(int n=0;n<data.length;n++)
			data[n] = st.nextToken();

		if(data[0].indexOf("set") == 0){
			int v[] = new int[4];

			for(int n=0;n<3;n++){
				v[n] = Extraction(data[n+1]);
				if(0 <= v[n] && v[n] <= 0xff)	continue;
				return val;
			}
			return new Color(v[0], v[1], v[2], v[3]);
		}
	}

	return val;
}

public static int setLog(StringTokenizer st)
{
	if(st.countTokens() == 0)		return -2;
	else if(st.countTokens() == 1){
		String data = st.nextToken();

		if(data.equals("show"))			return -3;
		else if(data.equals("min"))		return 0;
		else if(data.equals("max"))		return -4;
		else{
			int n = Extraction(data);

			if(0 <= n)	return n;
		}
	}
	return ERR;
}

public static void setScroll(StringTokenizer st, JTextAreaScroll ta)
{
	if(st.countTokens() == 0)			ta.changeScroll();
	else if(st.countTokens() == 1){
		String data = st.nextToken();
		boolean change;

		if(data.equals("on"))			change = ta.setScroll(true);
		else if(data.equals("off"))		change = ta.setScroll(false);
		else if(data.equals("show")){	change = true;
			if(ta.getScroll())	ta.addText("The scroll mode is changed to on.");
			else				ta.addText("The scroll mode is changed to off.");
		}
	}
	else								return;
}
/*
public static void setScrollText(JTextAreaScroll ta)
{

//	if(ta.getScroll())	ta.addText("The scroll mode is changed to on.");
//	else				ta.addText("The scroll mode is changed to off.");
}
*/
public static void setHighlight(StringTokenizer st, String all, JTextAreaScroll ta)
{
	if(st.countTokens() == 0)			ta.removeHighlights(true);
	else if(st.countTokens() >= 1){
		int n = all.indexOf("\"")+1;
		int m = all.lastIndexOf("\"");

		if(m != all.length()-1)	return;
		if(n >= m)				return;
		all = all.substring(n, m);
		ta.setHighlighter(all);
	}
}

public static void setTurn(StringTokenizer st, JTextAreaScroll ta)
{
	if(st.countTokens() == 0)			ta.changeTurn();
	else if(st.countTokens() >= 1){
		String data = st.nextToken();
		boolean change;

		if(data.equals("on"))			change = ta.setTurn(true);
		else if(data.equals("off"))		change = ta.setTurn(false);
		else if(data.equals("show")){	change = true;
			if(ta.getLineWrap())	ta.addText("The setting of the turn is on.");
			else					ta.addText("The setting of the turn is off.");
		}
	}
}




public static void saveText(JTextAreaScroll ta)
{
	ta.addText("save log \t"+saveData(ta.getText()));
}

public static String saveData(String data)
{
	try{
		String name = "tdos_"+saveFileName();
		data = data.replaceAll("\n", System.getProperty("line.separator"));

		PrintStream ps = new PrintStream(new File(name));
		ps.print(data);
		ps.close();

		return name;
	}
	catch(Exception ex){
		ex.printStackTrace();
	}
	return "err";
}

public static String saveFileName()
{
	return VERSION_STR+"_"+TimeData()+".log";
}


public static void BrowserIsExecuted(StringTokenizer st, String all)
{
	if(st.countTokens() == 0)	return;
	else if(st.countTokens() >= 1){
		int n = all.indexOf("\"")+1;
		int m = all.lastIndexOf("\"");

		if(m != all.length()-1)	return;
		if(n >= m)				return;
		all = all.substring(n, m);

		Browser(all);
	}
}

public static void Browser(String url)
{
	url = url.replaceAll(" ", "");
	url = url.replaceAll("@", "");

	if(url.indexOf("http://") == 0);
	else if(url.indexOf("ttp://") == 0)		url = "h"+url;
	else if(url.indexOf("tp://") == 0)		url = "ht"+url;
	else if(url.indexOf("p://") == 0)		url = "htt"+url;
	else if(url.indexOf("ttps://") == 0)	url = "h"+url;
	else if(url.indexOf("tps://") == 0)		url = "ht"+url;
	else if(url.indexOf("ps://") == 0)		url = "htt"+url;
	else if(url.indexOf("www") == 0)		url = "http://"+url;
	else if(url.indexOf("ftp.") == 0)		url = "ftp://"+url;
	else if(url.indexOf("irc.") == 0)		url = "irc:"+url;
	else if(url.indexOf("h") == 0){
		if(url.indexOf("p://") == 3){
			url = url.substring(7, url.length());
			url = "http://"+url;
		}
		else if(url.indexOf("s://") == 4){
			url = url.substring(8, url.length());
			url = "https://"+url;
		}
		else	return;
	}
	else		return;

	BrowserLauncher.openURL(url);
}
/*
public static String setCommnt(String data)
{
	if(data.indexOf("y") != -1)		data = data.replaceAll("y", "y.");

	if(data.indexOf("!omikuji") != -1)	data = data.replaceFirst("!omikuji", "y"+getOmikuji()+"z");
	if(data.indexOf("!number") != -1)	data = data.replaceFirst("!number", "y"+(int)(Math.random()*1000)+"z");
	if(data.indexOf("!dama") != -1)		data = data.replaceFirst("!dama", "y"+(int)(Math.random()*1000)+"z");
	if(data.indexOf("!kao") != -1)		data = data.replaceFirst("!kao", "y"+getKaomozi()+"z");
	if(data.indexOf("#") == 0)			data = "y"+getTrip(data)+"z";
	return data;
}
*/

private static final String omikuji[] = {"g", "g", "g", "g", "g", "", "勥"};

private static final String val[][] = 
{
	{""},

	{"Pnq","P","P~N","P","PÐ","PL","P","P_l",
	"Pq","P߉","P₳","PL","PV~Z","PJ",
	"Pؓc","P","j~"},

	{"J}hE}","nCyI","tCg搶","֑ł"},
	{"Vg","Vg","_","_","","","","","_","","","S", "l",""},
	{"","","Fl","ِEl","ʐl"},

	{"","叫","","","卲","","",
	"","","","y","","R","ޒ","","㓙","ꓙ","񓙕"},

	{"z","","","n","ΐ","ؐ","y","V","C",""},
	{"@","","Vp_","㌕"},

	{"","NNNN","zfX","l\","߂I","߰","fu","",
	"Ȃ䂫"}
};

public static String getOmikuji()
{
	int n = (int)(Math.random()*20);
	if(n != 0){
		n = (int)(Math.random()*omikuji.length);
		if((n == omikuji.length-1 || n == omikuji.length-2 || n == 0) && 0 == (int)(Math.random()*4))
			n = (int)(Math.random()*omikuji.length);
		return omikuji[n];
	}

	n = (int)(Math.random()*val.length);
	if(n == 0){
		if((int)(Math.random()*2) != 0)	n = (int)(Math.random()*val.length);
	}

	return val[n][(int)(Math.random()*val[n].length)];
}
/*
public static String getOmikuji()
{
	int n = (int)(Math.random()*1500);
	String d = omikuji[n%omikuji.length];

	switch(n){
		case 10:	case 20:	case 30:	case 40:	case 50:	d = "";	break;
		case 60:	case 70:	case 80:	case 90:	case 100:	d = "";	break;//
		case 110:	d = "Pnq";		break;
		case 120:	d = "P";			break;
		case 130:	d = "P~N";		break;
		case 140:	d = "P";			break;
		case 150:	d = "PÐ";			break;
		case 160:	d = "PL";		break;
		case 170:	d = "P";				break;
		case 180:	d = "P_l";				break;
		case 190:	d = "Pq";				break;
		case 200:	d = "P߉";			break;
		case 210:	d = "P₳";		break;
		case 220:	d = "PL";			break;
		case 230:	d = "PV~Z";		break;
		case 240:	d = "PJ";				break;
		case 250:	d = "Pؓc";			break;
		case 270:	d = "P";			break;
		case 280:	d = "j~";					break;

		case 300:	d = "J}hE}";			break;
		case 310:	d = "nCyI";			break;
		case 320:	d = "tCg搶";			break;
		case 330:	d = "֑ł";			break;

		case 500:	d = "Vg";				break;
		case 550:	d = "Vg";			break;
		case 510:	d = "_";				break;
		case 520:	d = "_";				break;
		case 530:	d = "";				break;
		case 540:	d = "";				break;
		case 560:	d = "_";				break;
		case 570:	d = "";				break;
		case 580:	d = "";				break;
		case 590:	d = "S";				break;
		case 600:	d = "l";				break;
		case 610:	d = "";				break;

		case 700:	d = "";				break;
		case 710:	d = "";				break;
		case 720:	d = "Fl";			break;
		case 730:	d = "ِEl";			break;
		case 740:	d = "ʐl";			break;

		case 820:	d = "y";					break;
		case 830:	d = "";					break;
		case 840:	d = "卲";					break;
		case 850:	d = "";					break;
		case 860:	d = "t";					break;
		case 870:	d = "";				break;
		case 880:	d = "卲";				break;
		case 890:	d = "";				break;
		case 900:	d = "";				break;
		case 910:	d = "叫";				break;
		case 920:	d = "t";				break;
		case 930:	d = "ޒ";				break;
		case 940:	d = "R";				break;
		case 950:	d = "ꓙ";				break;
		case 960:	d = "񓙕";				break;
		case 970:	d = "O";				break;
		case 980:	d = "㋉叫";				break;
		case 990:	d = "";					break;
		case 1300:	d = "";					break;
		case 1310:	d = "";					break;
		case 1320:	d = "y";					break;
		case 1330:	d = "";					break;
		case 1340:	d = "";					break;
		case 1350:	d = "R";					break;
		case 1360:	d = "";					break;
		case 1370:	d = "㓙";					break;

		case 1000:	d = "z";					break;
		case 1010:	d = "";				break;
		case 1020:	d = "";				break;
		case 1030:	d = "n";				break;
		case 1040:	d = "ΐ";				break;
		case 1050:	d = "ؐ";				break;
		case 1060:	d = "y";				break;
		case 1070:	d = "V";				break;
		case 1080:	d = "C";				break;
		case 1090:	d = "";				break;

		case 1100:	d = "@";				break;
		case 1110:	d = "";			break;
		case 1120:	d = "Vp_";				break;
		case 1130:	d = "㌕";				break;

		case 1210:	d = "";				break;
		case 1220:	d = "NNNN";	break;
		case 1230:	d = "zfX";	break;
		case 1240:	d = "l\";			break;
		case 1250:	d = "߂I";	break;
		case 1260:	d = "߰";		break;
		case 1270:	d = "fu";		break;
		case 1280:	d = "";		break;
		case 1290:	d = "Ȃ䂫";		break;
	}
	return d;
}
*/
private static final String kaomozi[] = {"_(OoO)^", "iOցOj", "( ְ)", "(ЁB)", 
			" (qBq* )", "(݁B)", "(^-^*)", "(*B)", "(EBEB )", 
			"iL֥`j", "(PP*)", "(^-^)U", "(^^)", "(߁)"};
/* jjg :l: @Ð
 jjg :l: @݂
 jjg :l: @
 jjg :l: (^D^)9m@߉
 jjg :l: @{
 jjg :l: @䝈ߎq
 jjg :l: @q
 jjg :l: ('(ÉE)')@nq
 jjg :l: (߃)(@݂
 jjg :l: <T-))@
 jjg :l: (L[M)@Ð
 jjg :l: ()@L
*/
public static String getKaomozi()
{
	return kaomozi[(int)(Math.random()*kaomozi.length)];
}

public static String getTrip(String d)
{
	try {
		// 
		String kagi = "tdos-zero";
		DESKeySpec dk = new DESKeySpec(kagi.getBytes());
		SecretKeyFactory kf = SecretKeyFactory.getInstance("DES");
		SecretKey sk = kf.generateSecret(dk);

		// Í
		Cipher c = Cipher.getInstance("DES");
		c.init(Cipher.ENCRYPT_MODE, sk);
		byte input[] = d.getBytes();
		byte encrypted[] = c.doFinal(input);    // Íf[^

		// 
//		c.init(Cipher.DECRYPT_MODE, sk);
//		byte output[] = c.doFinal(encrypted);   // f[^

		int n = new String(encrypted).hashCode();
		if(n < 0)	n *= -1;

		return ""+Integer.toString(n, Character.MAX_RADIX);
	}catch(Exception e){
		e.printStackTrace();
	}
	return "";
}



public static String TimeData()
{
	Calendar cal1 = Calendar.getInstance(TimeZone.getTimeZone("Asia/Tokyo"));

	String date;
	date = getStringData(cal1.get(Calendar.YEAR));
	date += ","+getStringData(cal1.get(Calendar.MONTH) + 1);
	date += ","+getStringData(cal1.get(Calendar.DATE));
	date += "_"+getStringData(cal1.get(Calendar.HOUR_OF_DAY));
	date += ";"+getStringData(cal1.get(Calendar.MINUTE));
	date += ";"+getStringData(cal1.get(Calendar.SECOND));

	return date;
}

public static String getStringData(int data)
{
	if(data < 10)	return "0"+data;
	return data+"";
}

public static int Extraction(String data)
{
	try{
		return Integer.parseInt(data);
	}
	catch(Exception ex){
		ex.printStackTrace();
		return ERR;
	}
}

public static int Extraction(String data, int v)
{
	try{
		return Integer.parseInt(data, v);
	}
	catch(Exception ex){
		ex.printStackTrace();
		return ERR;
	}
}

public static synchronized void Dialog(String comment, String title)
{
	Toolkit.getDefaultToolkit().beep();
	JOptionPane.showConfirmDialog(f, 
		comment, title, 
		JOptionPane.DEFAULT_OPTION, 
		JOptionPane.INFORMATION_MESSAGE);
}

public static synchronized void Sound()
{
	if(sound)	Toolkit.getDefaultToolkit().beep();
}

public static void Focus(Component c)
{
	FocusEvent event = new FocusEvent(c, FocusEvent.FOCUS_GAINED);
	Toolkit.getDefaultToolkit().getSystemEventQueue().postEvent(event);
}

public static void TestString(String data)
{
	if(test)	System.out.println(data.replaceAll("\n", " "));
}

}
