import java.awt.event.*;

public class KeyData extends Object implements KeyListener
{

private static Scene sc;

private boolean ENTER, SHIFT;
private boolean UP, DOWN, RIGHT, LEFT;
private boolean Z, X;


public KeyData()
{
	sc = null;
	AllReleased();
}

public static void setScene(Scene s)
{
	sc = s;
}

public void keyPressed(KeyEvent e)
{
	switch(e.getKeyCode()){
		case KeyEvent.VK_W:
		case KeyEvent.VK_UP:		UP = true;		break;
		case KeyEvent.VK_S:
		case KeyEvent.VK_DOWN:		DOWN = true;	break;
		case KeyEvent.VK_D:
		case KeyEvent.VK_RIGHT:		RIGHT = true;	break;
		case KeyEvent.VK_A:
		case KeyEvent.VK_LEFT:		LEFT = true;	break;
		case KeyEvent.VK_Z:			Z = true;		break;
		case KeyEvent.VK_X:			X = true;		break;
		case KeyEvent.VK_ENTER:		ENTER = true;	sc.KeyEnterEvent();	break;
		case KeyEvent.VK_SHIFT:		SHIFT = true;	break;
	}
}

public void keyReleased(KeyEvent e)
{
	switch(e.getKeyCode()) {
		case KeyEvent.VK_W:
		case KeyEvent.VK_UP:		UP = false;		break;
		case KeyEvent.VK_S:
		case KeyEvent.VK_DOWN:		DOWN = false;	break;
		case KeyEvent.VK_D:
		case KeyEvent.VK_RIGHT:		RIGHT = false;	break;
		case KeyEvent.VK_A:
		case KeyEvent.VK_LEFT:		LEFT = false;	break;
		case KeyEvent.VK_Z:			Z = false;		break;
		case KeyEvent.VK_X:			X = false;		break;
		case KeyEvent.VK_ENTER:		ENTER = false;	break;
		case KeyEvent.VK_SHIFT:		SHIFT = false;	break;
	}
}

public void keyTyped(KeyEvent e)
{

}


public void AllReleased()
{
	ENTER = SHIFT = false;
	UP = DOWN = RIGHT = LEFT = false;
	Z = X = false;
}


public boolean getEnter(){		return ENTER;	}
public boolean getShift(){		return SHIFT;	}
public boolean getUp(){			return UP;		}
public boolean getDown(){		return DOWN;	}
public boolean getRight(){		return RIGHT;	}
public boolean getLeft(){		return LEFT;	}
public boolean getZ(){			return Z;		}
public boolean getX(){			return X;		}

}
