import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import static java.awt.RenderingHints.*;

@SuppressWarnings({"unchecked", "serial"})

public class ServerFrame extends JFrame implements WindowListener, Basis
{

private Server se;



public static void main(String args[])
{
	Function.setTest(TEST_SERVER);
	Function.setLog(LOG_SERVER);
	Function.setErrorLog(LOG_ERROR_SERVER);
	Function.Option(args);

	Function.SystemOutput();
	Function.LogStreamOpen();

	new ServerFrame();
}

public ServerFrame()
{
	super();

	Function.setFrame(this);

	setTitle(TITLE+" server  "+VERSION_STR);
	setResizable(false);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width-WW)/2, (d.height-WH)/2);

	this.addWindowListener(this);


	se = new Server(this);

	Container c = getContentPane();
	c.add(se);

	pack();
	setVisible(true);
}



public void windowOpened(WindowEvent e)
{

}

public void windowClosing(WindowEvent e)
{
	Management.Exit();
}

public void windowClosed(WindowEvent e)
{

}

public void windowIconified(WindowEvent e)
{

}

public void windowDeiconified(WindowEvent e)
{

}

public void windowActivated(WindowEvent e)
{

}

public void windowDeactivated(WindowEvent e)
{

}

}
