import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import static java.awt.RenderingHints.*;

@SuppressWarnings({"unchecked", "serial"})

public class ClientFrame extends JFrame implements WindowListener, Basis
{

private Client cl;
private KeyData kd;


public static void main(String args[])
{
	Function.setTest(TEST_CLIENT);
	Function.setLog(LOG_CLIENT);
	Function.setErrorLog(LOG_ERROR_CLIENT);
	Function.Option(args);

	Function.SystemOutput();
	Function.LogStreamOpen();

	new ClientFrame();
}


public ClientFrame()
{
	super();

	Function.setFrame(this);

	setTitle(TITLE+"  "+VERSION_STR);
	setResizable(false);
	setLocationByPlatform(true);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

//	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
//	setLocation((d.width-WW)/2, (d.height-WH)/2);

	kd = new KeyData();
	cl = new Client(this, kd);

	Container c = getContentPane();
	c.add(cl);


	this.addWindowListener(this);

	pack();
	setVisible(true);
}


public void windowOpened(WindowEvent e)
{

}

public void windowClosing(WindowEvent e)
{
	Client.subExit();
}

public void windowClosed(WindowEvent e)
{

}

public void windowIconified(WindowEvent e)
{

}

public void windowDeiconified(WindowEvent e)
{

}

public void windowActivated(WindowEvent e)
{

}

public void windowDeactivated(WindowEvent e)
{
	kd.AllReleased();
}

}
