import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.*;
import java.util.*;

@SuppressWarnings({"unchecked", "serial"})


/************************************************************
	O:	DialogLogIn
	@\:	̃Xe[^X̐ݒ
************************************************************/

public class LogInDialog extends JDialog 
	implements ActionListener, TextListener, Basis
{

public static final int SELECT_OK = 1;
public static final int SELECT_CANCEL = 2;
public static final int SELECT_CLOSE = 3;
public static final int LIMIT = 115;

public static final int w = 250;
public static final int h = 150;

private JComboBox adr;
private JTextField na;
private JButton ok, no;

private int select;
private String address;
private String name;


/************************************************************
					ݒ and ֌W
************************************************************/


public static void main(String args[])
{
	new LogInDialog(new javax.swing.JFrame());
}

public LogInDialog(Frame f)
{
	super(f, "ݒ", true);
//	Toolkit.getDefaultToolkit().beep();

	select = SELECT_CLOSE;
	address = name = null;


	Container c = getContentPane();

	adr = new JComboBox();
	adr.setEditable(true);

	if(TEST)	adr.addItem("127.0.0.1");
	adr.addItem("tdos-zero.ddo.jp");
	if(!TEST)	adr.addItem("127.0.0.1");
	adr.addActionListener(this);


	na = new JTextField();
	na.setDocument(new LimitCheckDocument(na.getFontMetrics(new Font("Dialog.bold", Font.BOLD, 12)), LIMIT));
	na.addActionListener(this);

	ok = new JButton("OK");
	ok.addActionListener(this);
	ok.setSelected(true);
	no = new JButton("CANCEL");
	no.addActionListener(this);

	setLayout(null);
	na.setBounds(20, 10, 210, 25);
	adr.setBounds(20, 45, 210, 25);
	ok.setBounds(20, 85, 95, 20);
	no.setBounds(135, 85, 95, 20);

	c.add(adr);
	c.add(na);
	c.add(ok);
	c.add(no);

	Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
	setLocation((d.width-w)/2, (d.height-h)/2);
	setSize(w, h);
	setVisible(true);
}


/************************************************************
					ANV֌W
************************************************************/

public void actionPerformed(ActionEvent e)
{
	if(e.getSource() == ok){
		address = (String)adr.getSelectedItem();
		name = NameCheck((String)na.getText());
		
		if(name.length() < 1){
			address = name = null;
			na.setText("");
			return;
		}
		select = SELECT_OK;
		setVisible(false);
	}
	else if(e.getSource() == no){
		address = name = null;
		select = SELECT_CANCEL;
		setVisible(false);
	}
	else if(e.getSource() == na)	ok.doClick();
//	else if(e.getSource() == adr)	ok.doClick();
}

private String NameCheck(String data)
{
	StringBuffer sb = new StringBuffer(data);
	int start = NameCheck_getStart(sb);
	int end = NameCheck_getEnd(sb);

	if(start < end)	data = data.substring(start, end);

	String err_title = "mF";
	String err_message = "̖O͎gp邱Ƃł܂";

	FontMetrics fm = this.getFontMetrics(new Font("Dialog.bold", Font.BOLD, 12));

	if(LIMIT < fm.stringWidth(data))			err_message = "̖O͒܂";
	else if(data.indexOf(SERVER_NAME) != -1)	err_message = "Ȃ͍r炵łH";
	else if(data.indexOf(NO_NAME) != -1)		err_message = "Ȃ͍r炵łH";
	else if(data.indexOf("{") != -1)			err_message = "xAI";
	else if(data.indexOf("nq") != -1)		err_message = "̐lԂɂ͋܂B";
	else if(data.indexOf("L") != -1)		err_message = "^̃Azc";
	else if(data.indexOf("L") != -1)			err_message = "vEEEEEȂ";
	else if(data.indexOf("") != -1)			err_message = "j[N";
	else if(data.indexOf("L") != -1)			err_message = "ዾĉH";
	else if(data.indexOf("YUKI") != -1)			err_message = "YUKI.N>sleeping beauty";
	else if(data.indexOf("") != -1)		err_message = "PāAmĂ܂H";
	else if(data.indexOf("݂") != -1)		err_message = "֑łB";
	else if(data.indexOf("~N") != -1)		err_message = "݂cc~Nr[I";
	else if(data.indexOf("Ð") != -1)			err_message = "ϯް";
	else if(data.indexOf("") != -1)			err_message = "ӂӁI";
	else if(data.indexOf("CcL") != -1)		err_message = "CcLNAȂ̂肶傤ɂ͂܂!";
	else if(data.indexOf("q") != -1)			err_message = "ႠEEEŁB";
	else if(data.indexOf("q") != -1)			err_message = "Aꖳ";
	else if(data.indexOf("߉") != -1)			err_message = "߂I";
	else if(data.indexOf("") != -1)		err_message = "ɂɂ";
	else if(data.indexOf("") != -1)			err_message = "ނwZɂĂȂłcc";
	else if(data.indexOf("]") != -1)		err_message = "SzŁcc";
	else if(data.indexOf("J") != -1)			err_message = "WAWAWAYꕨ`";
	else if(data.indexOf("ؓc") != -1)		err_message = "W";
//	else if(data.indexOf("X") != -1)			err_message = "W";
	else if(data.indexOf("V") != -1)			err_message = "W";
	else if(data.indexOf("") != -1)			err_message = "W";
	else if(data.indexOf("\") != -1)			err_message = "W";
//	else if(data.indexOf("T") != -1)			err_message = "W";
	else if(data.indexOf("") != -1)			err_message = "NƏ񂾏I";
	else if(data.indexOf("O") != -1)		err_message = "W";
	else if(data.indexOf("V~Z") != -1)	err_message = "܂ȂAlԂ̌t݂ܶ̂";
	else if(data.indexOf("ENOZ") != -1)			err_message = "W";
	else if(data.indexOf("Mq") != -1)		err_message = "W";
	else if(data.indexOf("O") != -1)		err_message = "W";
	else if(data.indexOf("|{[I") != -1)	err_message = "W";
	else if(data.indexOf("") != -1)		err_message = "W";
	else if(data.indexOf("_l") != -1)			err_message = "j󂷂邱Ƃ͋܂";
	else if(data.indexOf("ブpC[c") != -1)	err_message = "W";
	else if(data.indexOf("hpTCR[I") != -1)	err_message = "Œ߉̓Q[𖳗ŊyނƂł܂B";
	else if(data.indexOf("204TCR[I") != -1)	err_message = "ŒÑQ[𖳗ŊyނƂł܂B";
	else if(data.indexOf("zeroTCR[I") != -1)	err_message = "łȂ͂̃Q[𖳗ŊyނƂł܂B";
	else if(data.indexOf("Ri~TCR[I") != -1)	err_message = "ŃRi~Ј͂̃Q[𖳗ŊyނƂł܂B";
	else if(start < end)		return data;


	JOptionPane.showMessageDialog(this, 
		err_message, err_title, 
		JOptionPane.INFORMATION_MESSAGE);

	return "";
}

private int NameCheck_getStart(StringBuffer sb)
{
	for(int n=0;n<sb.length();n++){
		switch(sb.charAt(n)){
			case ' ':
			case '@':	break;
			default:	return n;
		}
	}
	return sb.length();
}

private int NameCheck_getEnd(StringBuffer sb)
{
	for(int n=sb.length()-1;n>=0;n--){
		switch(sb.charAt(n)){
			case ' ':
			case '@':	break;
			default:	return n+1;
		}
	}
	return 0;
}




public void textValueChanged(TextEvent e)
{
	System.out.println("test");
}


/************************************************************
					f[^[ANZX֌W
************************************************************/

public int getSelect(){		return select;		}
public String getAddress(){	return address;		}
public String getName(){	return name;		}

}





class LimitCheckDocument extends PlainDocument
{

FontMetrics fm;
int limit;

public LimitCheckDocument(FontMetrics fm, int limit)
{
	super();
	this.fm = fm;
	this.limit = limit-fm.getMaxAdvance();
}

public void insertString(int offs, String str, AttributeSet a)throws BadLocationException
{
	if(limit < fm.stringWidth(getText(0, getLength()))){
		super.insertString(offs , null , a);
		return;
	}
	super.insertString(offs , str , a);
}

/*
public void insertString(int offs, String str, AttributeSet a)throws BadLocationException
{
	int now = fm.stringWidth(getText(0, getLength()));
	int d = fm.stringWidth(str);
//	String data = getText(0, getLength())+str;

	if(limit < now){
		if(limit < now)			super.insertString(offs , null, a);
		else if(limit < d+now){
			if(str.length() == 0)	super.insertString(offs , str, a);
			for(int n=str.length()-1;n>=1;n--){
				String s = str.substring(0, n);
				if(limit < now+fm.stringWidth(s))	super.insertString(offs , s, a);
			}
		}

		super.insertString(offs , null , a);
		String data = getText(0, getLength());
		int m = 0;
		for(int n=data.length();n>=1;n--){
			String s = data.substring(0, n);

			if(limit > fm.stringWidth(s)){
				remove(n, m);
				return;
			}
			m++;
		}

		return;
	}
	super.insertString(offs , str , a);

	super.insertString(offs , str , a);
	String data = getText(0, getLength());
	int m = 0;
	for(int n=data.length();n>=1;n--){
		String s = data.substring(0, n);

		if(limit > fm.stringWidth(s)){
			remove(n, m);
			return;
		}
		m++;
	}

}
*/
}
