class MyButton extends Object
{

public static final int IW = 200;
public static final int IH = 50;

private int x, y;
private int chip;
private boolean active;
private String data, english;



public MyButton(String data, String english, int x, int y, int chip)
{
	this.x = x;
	this.y = y;
	this.chip = chip;
	this.data = data;
	this.english = english;

	active = false;
}

public boolean isActive(int vx, int vy)
{
	boolean val = active;

	if(x < vx && vx < x+IW && y < vy && vy < y+IH)
			active = true;
	else	active = false;

	return val == active? false: true;
}

public boolean isHit(int vx, int vy)
{
	if(x < vx && vx < x+IW && y < vy && vy < y+IH)
		return true;
	return false;
}

public boolean getActive()
{
	return active;
}

public String getString()
{
	return data;
}

public String getStringEnglish()
{
	return english;
}

public int getX()
{
	return x;
}

public int getY()
{
	return y;
}

public int getImageX()
{
	return active? IW: 0;
}

public int getImageY()
{
	return chip*IH;
}

}
