import java.io.*;
import java.net.*;
import java.awt.*;
import java.awt.im.*;
import java.awt.image.*;
import java.awt.event.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import static java.awt.RenderingHints.*;

@SuppressWarnings({"unchecked", "serial"})

public class Server extends JPanel 
	implements Runnable, ActionListener, MouseListener, MouseMotionListener, Basis
{

private JFrame f;
private Thread t;

private boolean Process;
private Management ma;



public Server(JFrame f)
{
	this.f = f;
	Contract();
}

public void Contract()
{
	setPreferredSize(new Dimension(WW, WH));

	Process = true;

	ma = new Management(f, this);
	setFocusable(true);
	addMouseListener(this);
	addMouseMotionListener(this);

	t = new Thread(this);
	t.start();
}


public void run()
{
	while(Process){
		ma.MainLoop();
	}
}




public void actionPerformed(ActionEvent e)
{
	ma.ActionPerformed(e);
}



public void mouseMoved(MouseEvent e)
{
//	ma.MouseMoved(e);
}

public void mouseDragged(MouseEvent e)
{

}



public void mousePressed(MouseEvent e)
{
	ma.MousePressed(e);
}

public void mouseReleased(MouseEvent e)
{
	ma.MouseReleased(e);
}

public void mouseClicked(MouseEvent e)
{

}

public void mouseEntered(MouseEvent e)
{

}

public void mouseExited(MouseEvent e)
{

}


public void paintComponent(Graphics G)
{
	super.paintComponent(G);
}



public void ExitProcess()
{
	Process = false;
}

}